numbumps = 4; %4 or 8
matfile = '15030612+13_pos.mat';
% name = '15030612+13_bumps.02d" % (numbumps)

% parameters of the model
extinp = 1;
alpha = 0.15;
ell = 2;
inh = -0.01;
R  = 20;
Nx = 28;
Ny = 44;

if(numbumps==4)    
  Nx=Nx*2;
elseif(numbumps==8)
  Nx=Nx*2;
  Ny=Ny*2;
end

NG=Nx*Ny;

%% MAKE CONNECTIVITY WITH AN OFFSET RELATIVE TO PREFERRED DIRECTION
theta = zeros([Nx,Ny]);
theta(1:2:Nx,1:2:Ny) = 0;
theta(2:2:Nx,1:2:Ny) = 1;
theta(1:2:Nx,2:2:Ny) = 2;
theta(2:2:Nx,2:2:Ny) = 3;
theta = theta'.*(0.5*pi);
theta1 = theta;
theta = theta(:);

xes = zeros([Nx,Ny]);
yes = zeros([Nx,Ny]);
for x =1:Nx
  for y = 1:Ny
    xes(x,y) = x-1;
    yes(x,y) = y-1;
  end
end
xes = xes';
yes = yes';
xes = xes(:);
yes = yes(:);

Rsqrd = R^2;
W = zeros([NG,NG]);
for xi = 0:Nx-1
  xdiffA = abs(xes-xi-ell*cos(theta));
  xdiffB = Nx-xdiffA;
  xdiffA = xdiffA.^2;
  xdiffB = xdiffB.^2;
  for y = 0:Ny-1
    n = xi*Ny+y+1;
    ydiffA = abs(yes-y-ell*sin(theta));
    ydiffB = Ny-ydiffA;
    ydiffA = ydiffA.^2;
    ydiffB = ydiffB.^2;
    d = xdiffA+ydiffA;
    W(d<Rsqrd,n) = W(d<Rsqrd,n) + inh;
    d = xdiffB+ydiffA;
    W(d<Rsqrd,n) = W(d<Rsqrd,n) + inh;
    d = xdiffA+ydiffB;
    W(d<Rsqrd,n) = W(d<Rsqrd,n) + inh;
    d = xdiffB+ydiffB;
    W(d<Rsqrd,n) = W(d<Rsqrd,n) + inh;
  end
end
xes=0;
yes=0;
N = NG;

%%  LOAD UP MOVEMENT DATA
mat = load(matfile);
posx = mat.posx(:);
posy = mat.posy(:);
post = mat.post(:);
mat = 0;

post = post(isfinite(posx));
posy = posy(isfinite(posx));
posx = posx(isfinite(posx));
post = post(isfinite(posy));
posx = posx(isfinite(posy));
posy = posy(isfinite(posy));
post = post.*1000;
side = max(max(posx)-min(posx), max(posy)-min(posy));
posx = posx./side;
posy = posy./side;
posx = posx - min(posx);
posy = posy -min(posy);

tnew = 0:599000;
posx = interp1(post, posx, tnew);
posy = interp1(post, posy, tnew);
post = tnew;

%Get angles and velocities
angs = zeros(length(post),1);
angs(1:end-1) = atan2(posy(2:end)-posy(1:end-1), posx(2:end)-posx(1:end-1));
angs(end) = angs(end-1);
speeds = 1000.*sqrt((posx(2:end)-posx(1:end-1)).^2+(posy(2:end)-posy(1:end-1)).^2);
nums = length(speeds);
post=0;

%% INITIALIZE ACTIVITY TO RANDOM AND LET IT FIND PATTERN
S = zeros(Nx*Ny,1);
S(logical(rand([1,Nx*Ny])> 0.1)) = 1;
for t = 1:2000
  S = S + 0.1*(-S + max((extinp+W*S),0.));
  S(logical(S<0.00001)) = 0;
end

maxS = max(S(:));
minx = min([min(posy),min(posx)]);
maxx = max([max(posy),max(posx)]);
whichn = randi(length(S(:))-1, [1 3]);
nodes = zeros([3, nums]);
% Sout = zeros(length(S),nums);
for t = 101:nums
    inp = alpha*speeds(t)*cos(angs(t)-theta1);
    
    S = S + 0.1*(-S + max((extinp+W*S+inp),0));
    if(mod(t,10)==0)
        S(logical(S<0.0001)) = 0;
    end
    Sout(:,t) = S;
end

scatter(posx(1:end-1),posy(1:end-1),[],Sout(10,:),'filled');
save('GridData3', 'Sout', 'angs', 'posx','posy', '-v7.3');

