boundLow = -0.5;
boundHigh = 0.5;
numholes = 0;
numtimesteps = 1500;
len = 100000;
[posx, posy, posz, angs3, angs2, angs1] = GetRandomFlight(boundLow, boundHigh, numholes, numtimesteps, len);

rng('shuffle');
noisevar = 0;%0.2;
varterm= 0.4;
alpha = 0.3;
dt= 10;
N = 100;
Rmin = 25;
inh = 0.05;
n = 10;
extinp = 1;
dtinv = 10;
tau = 10;
xes = zeros(N, 1);
for x = 1:N
    xes(x) = x;
end
W = zeros(N,N);
for x = 1:N
    xdiff = abs(xes-x);
    xdiff = min(xdiff, N-xdiff);
    W(x,xdiff>Rmin) = -inh;
end

preferencefromsomewhere1 = (1:N)'*2*pi/(N) - pi  + noisevar * normrnd(0,pi, N,1);
preferencefromsomewhere2 = (1:N)'*2*pi/(N) - pi  + noisevar * normrnd(0,pi, N,1);
preferencefromsomewhere3 = (1:N)'*2*pi/(N) - pi  + noisevar * normrnd(0,pi, N,1);

S1 = zeros(N,1); %yaw
S2 = zeros(N,1); %pitch
S3 = zeros(N,1); %pitch

for i = 1:floor(40)
    S1(ceil(rand()*(N))) = rand();
    S2(ceil(rand()*(N))) = rand();
    S3(ceil(rand()*(N))) = rand();
end

numStable = 201;
for t = 1:numStable %% let stable pattern form
    S1 = S1 + 1./(dtinv+tau) * (-S1 + max(0., extinp+W*S1));
    S2 = S2 + 1./(dtinv+tau) * (-S2 + max(0., extinp+W*S2));
    S3 = S3 + 1./(dtinv+tau) * (-S3 + max(0., extinp+W*S3));
end
len = length(posx);
Sout1 = zeros(N,len);
Sout2 = zeros(N,len);
Sout3 = zeros(N,len);
for t = dt+1:1:len-dt
    %% Azimuth/yaw
    ang1 = angs1(t);
    dd1 = ang1-preferencefromsomewhere1;
    dd1(logical(dd1>pi)) = dd1(logical(dd1>pi))-2.*pi;
    dd1(logical(dd1<-pi)) = dd1(logical(dd1<-pi))+2.*pi;
    inp1 = alpha * exp( - dd1.^2 / (2.*varterm));
    %% Pitch     
    ang2 = angs2(t);
    dd2 = ang2-preferencefromsomewhere2;
    dd2(logical(dd2>pi)) = dd2(logical(dd2>pi))-2.*pi;
    dd2(logical(dd2<-pi)) = dd2(logical(dd2<-pi))+2.*pi;
    inp2 = alpha * exp( - dd2.^2 / (2.*varterm) );
    
    %% Roll
    ang3 = angs3(t);
    dd3 = ang3-preferencefromsomewhere3;
    dd3(logical(dd3>pi)) = dd3(logical(dd3>pi))-2.*pi;
    dd3(logical(dd3<-pi)) = dd3(logical(dd3<-pi))+2.*pi;
    inp3 = alpha * exp( - dd3.^2 / (2.*varterm) );
    

    %% numerically integrate firing rate
    for i = 1:dt
        S1 = S1 + 1./(dtinv+tau) * (-S1 + max(0., extinp + inp1 +  W*S1));
        S2 = S2 + 1./(dtinv+tau) * (-S2 + max(0., extinp + inp2 +  W*S2));
        S3 = S3 + 1./(dtinv+tau) * (-S3 + max(0., extinp +  inp3 + W*S3));
    end
    Sout1(:,t) = S1(:);
    Sout2(:,t) = S2(:);
    Sout3(:,t) = S3(:);
end

spikes = FiringRateToSpikes(Sout1);
S1 = SmoothSpikes(spikes);
spikes2 = FiringRateToSpikes(Sout2);
S2 = SmoothSpikes(spikes2);
spikes1 = FiringRateToSpikes(Sout3);
S3 = SmoothSpikes(spikes1);

% if(saveData)
    save('HeadData_AxPxR', 'S1', 'S2', 'S3', 'posx', 'posy', 'posz', 'angs1', 'angs2', 'angs3');
% end

neurons = 70;%:20:100;
timesteps = 1:1:t;
figure;
polarplot(angs1(timesteps),Sout1(neurons,timesteps), '*');
figure;
polarplot(angs2(timesteps),Sout2(neurons,timesteps), '*');
figure;
polarplot(angs3(timesteps),Sout3(neurons,timesteps), '*');

