oneHole = false;
fourHoles = true;
saveData = false;
filmMovement = false;
boundLow = -0.5;
boundHigh = 0.5;
numholes = 0;
numtimesteps = 1000;
len = 100000;
[posx, posy, posz, angs3, angs2, angs1] = GetRandomFlight(boundLow, boundHigh, numholes, numtimesteps, len);

rng('shuffle');
noisevar = 0;
varterm= 0.4;
alpha = 0.3;
dt= 1;
N = 10;
Rmin = 3;
inh = 0.05;
extinp = 1;
dtinv = 10;
tau = 10;

preferencefromsomewhere1 = zeros(N,N,N);
preferencefromsomewhere2 = zeros(N,N,N);
preferencefromsomewhere3 = zeros(N,N,N);

for i = 1:N
    for j = 1:N
        for k = 1:N
            preferencefromsomewhere1(i,j,k) = i*2*pi/(N) - pi  + noisevar * normrnd(0,pi);
            preferencefromsomewhere2(i,j,k) = j*2*pi/(N) - pi  + noisevar * normrnd(0,pi);
            preferencefromsomewhere3(i,j,k) = k*2*pi/(N) - pi  + noisevar * normrnd(0,pi);
        end
    end
end

w1 = zeros(N*N*N,N*N*N);
for l = 1:N
    for m = 1:N
        for n = 1:N
            for i = 1:N
                for j = 1:N
                    for k = 1:N
                        d1 = abs(l-i);
                        d2 = abs(m-j);
                        d3 = abs(n-k);
                        d1 = min(d1, N-d1);
                        d2 = min(d2, N-d2);
                        d3 = min(d3, N-d3);
                        if ((d1^2 + d2^2 + d3^2)^0.5 > Rmin)
                            w1((l-1)*N*N+(m-1)*N + n,(i-1)*N*N+(j-1)*N +k) = -inh;
                        end
                    end
                end
            end            
        end
    end
end

S = zeros(N,N,N); %place

for i = 1:N
    for j = 1:N
        for k = 1:floor(N/5)
            S(i, j, ceil(rand()*N)) = rand();
        end        
        for k = 1:floor(N/5)
            S(i, ceil(rand()*N), j) = rand();
        end
        for k = 1:floor(N/5)
            S(ceil(rand()*N), i, j) = rand();
        end
    end
end

numStable = 201;
for t = 1:numStable %% let stable pattern form
    S = S + 1./(dtinv+tau) * (-S + max(0., extinp+reshape(w1*S(:), size(S))));
end

Sout = zeros(N*N*N,len);
for t = dt+1:dt:len-dt
    %% Azimuth/yaw
    ang1 = angs1(t);
    dd1 = ang1-preferencefromsomewhere1;
    dd1(logical(dd1>pi)) = dd1(logical(dd1>pi))-2.*pi;
    dd1(logical(dd1<-pi)) = dd1(logical(dd1<-pi))+2.*pi;
    inp1 = alpha * exp( - dd1.^2 / (2.*varterm));
    %% Pitch
    ang2 = angs2(t);
    dd2 = ang2-preferencefromsomewhere2;
    dd2(logical(dd2>pi)) = dd2(logical(dd2>pi))-2.*pi;
    dd2(logical(dd2<-pi)) = dd2(logical(dd2<-pi))+2.*pi;
    inp2 = alpha * exp( - dd2.^2 / (2.*varterm) );
    
    %% Roll
    ang3 = angs3(t);
    dd3 = ang3-preferencefromsomewhere3;
    dd3(logical(dd3>pi)) = dd3(logical(dd3>pi))-2.*pi;
    dd3(logical(dd3<-pi)) = dd3(logical(dd3<-pi))+2.*pi;
    inp3 = alpha * exp( - dd3.^2 / (2.*varterm) );
    
    %% numerically integrate firing rate
    for i = 1:10
%         Stemp = S';
        S = S + 1./(dtinv+tau) * (-S + max(0., extinp + (inp1 + inp2 + inp3) +  reshape(w1*S(:), size(S))));% + reshape(w2*S(:), size(S))));
    end
    Sout(:,t) = S(:);
end


% spikes = FiringRateToSpikes(Sout);
% S = SmoothSpikes(spikes);
%

% save('RP3_data', 'Sout', 'posx', 'posy', 'posz', 'angs1', 'angs2', 'angs3');
S = Sout(:,1:t);
angs1 = angs1(1:t);
angs2 = angs2(1:t);
angs3 = angs3(1:t);

neurons = 70;%:20:100;

timesteps = 1:1:size(S,2);
figure;
polarplot(angs1(timesteps),S(neurons,timesteps), '*');
figure;
polarplot(angs2(timesteps),S(neurons,timesteps), '*');
figure;
polarplot(angs3(timesteps),S(neurons,timesteps), '*');
