%% This Script computes periodic place cell network activity

rng('shuffle');
noisevar1 = 0;%0.05;
varterm1 = 0.015;
alpha1 = 0.3;
dt= 10;
inh1 = 0.05;
n = 20;
N = n^2;
extinp = 1;
dtinv = 10;
tau = 10;
film1 = false;
film2 = false;
R = 2.5;

A = load('animal_movement.mat');
posx = A.posx;
posy = A.posy;
posx = posx(1:100000);
posy = posy(1:100000);

% numholes = 1;
% % %%  LOAD UP MOVEMENT DATA
% % % if (numholes >0)
% minD = -0.5;
% maxD = 0.5;
% numtimesteps = 2000;
% len = 100000;
% [posx, posy, angs1] = GetRandomWalk(minD, maxD, numholes, numtimesteps, len);

preferencefromsomeplacex = zeros(n,n);
preferencefromsomeplacey = zeros(n,n);
for i = 1:n
    preferencefromsomeplacex(i,:) = (1:n)'*2*0.5/(n) - 0.5 + noisevar1 * normrnd(0,0.5, n,1);
    preferencefromsomeplacey(:,i) = (1:n)'*2*0.5/(n) - 0.5 + noisevar1 * normrnd(0,0.5, n,1);
end

x1 = zeros(n,n);
% y1 = zeros(n,n);
% for i = 1:n
%     x1(i,:) = (0:n-1)'*1/(n-1)-0.5;
%     y1(:,i) = (0:n-1)'*1/(n-1)-0.5;
% end

w = zeros(N,N);
for k = 1:n
    for l = 1:n
        for i = 1:n
            for j = 1:n
                xdiff = abs(k - i);
                xdiff = min(xdiff, n-xdiff);
                ydiff = abs(l - j);
                ydiff = min(ydiff, n-ydiff);               
                if ((R-((xdiff)^2+...
                        (ydiff)^2)^0.5) < 0)
                    w((k-1)*n+l,(i-1)*n+j) = -inh1;
                end
            end
        end
    end
end

S1 = zeros(n,n); %place
% S1(randi(n^2, [floor(n^2/100) 1])) = 1;

for j = 1:n
    for i = 1:floor(n/5)
        S1(ceil(rand()*n), j) = rand();
    end
    for i = 1:floor(n/5)
        S1(j, ceil(rand()*n)) = rand();
    end
end

numStable = 200;
F1(floor(numStable/2)) = struct('cdata',[],'colormap',[]);
for t = 1:numStable %% let stable pattern form
    S1 = S1 + 1./(tau) * (-S1 + max(0., extinp+reshape(w*S1(:), size(S1))));
    if(mod(t,2)==0 && film1)
        plot(S1, '-');
        ylabel('Place Cells');
        xlabel('Neurons');
        drawnow;
        F1(t) = getframe(gcf);
    end
end

% len = length(posx);
len = 100000;
SoutP = zeros(n*n,len);
angP = zeros(len, 1);
for t = dt+1:length(posx)-dt
    if(abs(posx(t))>0.55)
        break;
    end   
    ang = atan2((posy(t+dt)-posy(t-dt)),(posx(t+dt)- posx(t-dt)));
    angP(t,:) = ang;
%      v = ((posy(t+dt)-posy(t-dt))^2+(posx(t+dt)- posx(t-dt))^2)^0.5/(2*dt/1000);
 
    %% place cells
    dpx = abs(posx(t)-preferencefromsomeplacex);
    dpx = (min(dpx, abs(1-dpx))).^2;
    dpy = abs(posy(t)-preferencefromsomeplacey);
    dpy = (min(dpy, abs(1-dpy))).^2;
%     inp1 = alpha1 *v* cos(sqrt(dpx+dpy)*pi/sqrt(2));
    inp1 = alpha1*exp( - (dpx + dpy)/ (varterm1) );
%     inp1 = exp( - (dpx + dpy)/ (varterm1) );
   
     
    %% numerically integrate firing rate
    for i = 1:dt
        S1 = S1 + 1./(tau) * (-S1 + max(0., extinp +  inp1 + reshape(w*S1(:), size(S1))));% reshape(W*S1(:), size(S1))));
    end
    SoutP(:,t) = S1(:);
end

SoutTemp = SoutP(:,1:t);
spikes = FiringRateToSpikes(SoutP);
S1 = SmoothSpikes(spikes);

% 
% timesteps = 1:1:size(S1,2);
% for what = 50:51
%     figure
%     scatter(posx(timesteps), posy(timesteps), [], S1(what,timesteps));
% % end
% t = 94500;
% S1 = S1(:,1:t);
% SoutTemp = SoutP(:,1:t);
timesteps = 1:1:size(SoutP,2);
for what = 218:221
    figure
    scatter(posx(timesteps), posy(timesteps), [], SoutP(what,timesteps));
end
% posx = posx(1:94500);
% posy = posy(1:94500);
save('PeriodicPlaceData_final4', 'SoutP', 'posx', 'posy', '-v7.3');
% end