function [x,y,z,roll, pitch, yaw] = GetRandomFlight(min, max, numholes, numtimesteps, len)
numSpins = 0;
count = 0;
% while (numSpins < 1 || count == 10)
    count = count +1;
    numSpins = 0;
    x = zeros(numtimesteps,1);
    y = zeros(numtimesteps,1);
    z = zeros(numtimesteps,1);
    maxlen = max-min;
    x(1:2) = ones(2,1)*rand()*maxlen-maxlen/2;
    y(1:2) = ones(2,1)*rand()*maxlen-maxlen/2;
    z(1:2) = ones(2,1)*rand()*maxlen-maxlen/2;
    holes = [];
    if (numholes>0)
        r = 0.15;
        holes = [0 0 0];
        %     holes = [inf in%f];
        %     tempholes = numholes;
        %     while(tempholes>0)
        %         tempx = rand()*maxlen+min;
        %         tempy = rand()*maxlen+min;
        %         if (find((((holes(:,1) - tempx).^2 +(holes(:,2) - tempy).^2).^0.5) < r))
        %             continue
        %         else
        %             holes = [holes; tempx tempy];
        %             tempholes = tempholes-1;
        %         end
        %     end
        
        while(find((((holes(:,1) - x(1)).^2 +(holes(:,2) - y(1)).^2+(holes(:,3) - z(1)).^2).^0.5) < r))
            x(1) = rand()-0.5;
            y(1) = rand()-0.5;
            z(1) = rand()-0.5;
        end
    end
    v = 0.2;
    stddev = 0.05*v;
    for i = 3:numtimesteps
        newstep = false;
        while (~newstep)
            dX= [x(i-1)-x(i-2); y(i-1)-y(i-2); z(i-1)-z(i-2)];
            dir = [normrnd(dX(1), 0.1); normrnd(dX(2), 0.1);normrnd(dX(3), 0.1)];
            if (dir~=0)
                dir = dir.*normrnd(v,stddev)/norm(dir);
            else
                dir = [0.0001*(rand()-0.5), 0.0001*(rand()-0.5), 0.0001*(rand()-0.5)];
            end
            tempx = x(i-1) + dir(1);
            tempy = y(i-1) + dir(2);
            tempz = z(i-1) + dir(3);
            if(tempx > 0.99*max || tempx < 1.01*min || tempy > 0.99*max || tempy < 1.01*min || tempz > 0.99*max || tempz < 1.01*min)
                continue;
            elseif(~isempty(holes))
                if  (find((((holes(:,1) - tempx).^2 +(holes(:,2) - tempy).^2+(holes(:,3) - tempz).^2).^0.5) < 1.01*r))
                    continue;
                end
            end
            newstep = true;
        end
        x(i) = tempx;
        y(i) = tempy;
        z(i) = tempz;
    end
    % figure
    % plot3(x,y,z);
    % axis([-0.5 0.5 -0.5 0.5 -0.5 0.5])
    
    W = cscvn([x y z]');
    % figure
    % fnplt(W,'r',1)
    % comet3(X(:,1),X(:,2),X(:,3));
    stop = numtimesteps/3;
    start = 1;
    dt = (stop-start)/(len-1);
    u = ppval(W, start:dt:stop);
    x = u(1,1:end);
    y = u(2,1:end);
    z = u(3,1:end);
    % figure
    % plot3(x,y,z);
    % axis([-0.5 0.5 -0.5 0.5 -0.5 0.5])
    
    
    % Xq = 1:10000;
    % Yq = 1:10000;
    % Zq = interp2(x,y,z,Xq',Yq');
    %
    % figure
    % plot3(Xq,Yq,Zq);
    % axis([-0.5 0.5 -0.5 0.5 -0.5 0.5])
    
    roll = zeros(1,len);
    pitch = zeros(1,len);
    yaw = zeros(1,len);
    dt = 10;
    upright = true;
    yaw(1:10) = ones(1,10)*(rand()-0.5)*2*pi;
    pitch(1:10) = ones(1,10)*(rand()-0.5)*2*pi;
    roll(1:10) = ones(1,10)*(rand()-0.5)*2*pi;
    for t = 1+dt:1:len-dt-1
        dx = x(t+dt) - x(t-dt);%mean(x(t:t+dt))- mean(x(t-dt:t));
        dy = y(t+dt) - y(t-dt);%mean(y(t:t+dt))- mean(y(t-dt:t));
        dz = z(t+dt) - z(t-dt);%mean(z(t:t+dt))- mean(z(t-dt:t));
        dx1 = x((t+1)+dt) - x((t+1)-dt);%mean(x(t:t+dt))- mean(x(t-dt:t));
        dy1 = y((t+1)+dt) - y((t+1)-dt);%mean(y(t:t+dt))- mean(y(t-dt:t));
        dz1 = z((t+1)+dt) - z((t+1)-dt);%mean(z(t:t+dt))- mean(z(t-dt:t));
        
        yaw(t) = angle(dx + 1i*dy);
        pitch(t) = angle((dx^2 + dy^2)^0.5+1i*dz);
        yaw_next = angle(dx1 + 1i*dy1);
        pitch_next = angle((dx1^2 + dy1^2)^0.5+1i*dz1);
        pitch(t) = pitch(t-1) + pi/8*(normrnd(0,0.1));  
        if(roll(t)>pi)
            roll(t) = roll(t)-2.*pi;
        elseif(roll(t)<-pi)
            roll(t) = roll(t)+2.*pi;
        end
        diff = 2;
        if (upright &&  (pitch_next > pi/2 - diff*(pitch(t-1)-pitch(t-2)) ...
                || pitch_next < -pi/2 - diff*(pitch(t-1)-pitch(t-2))) ...
                && (abs(abs(yaw_next) - abs(yaw(t))) > pi/4))
            
%             ((abs(yaw(t-1)) < pi/2 && abs(yaw(t)) > pi/2) ...
%                 || (abs(yaw(t-1)) > pi/2 && abs(yaw(t)) < pi/2)))
            upright = false;
            numSpins = numSpins + 1;
        elseif (~upright && ((pitch_next > 0 && pitch_next < pi/2 - diff*(pitch(t-1)-pitch(t-2))) ...
                || (pitch_next < 0 && pitch_next > -pi/2 - diff*(pitch(t-1)-pitch(t-2)))) ...
                && (abs(abs(yaw_next) - abs(yaw(t))) > pi/4))            
%             (abs(yaw(t-1))< pi/2 && abs(yaw(t)) > pi/2 ...
%                 || abs(yaw(t-1))> pi/2 && abs(yaw(t)) < pi/2))
            upright = true;
        end
        if(~upright)
            yaw(t) = yaw(t) + pi;
            if (pitch(t) < 0)
              pitch(t) = -pi - pitch(t);
            else
                pitch(t) = pi - pitch(t);
            end
              roll(t) = roll(t);
            if(yaw(t)>pi)
                yaw(t) = yaw(t)-2.*pi;
            elseif(yaw(t)<-pi)
                yaw(t) = yaw(t)+2.*pi;
            end
            if(pitch(t)>pi)
                pitch(t) = pitch(t)-2.*pi;
            elseif(pitch(t)<-pi)
                pitch(t) = pitch(t)+2.*pi;
            end
            if(roll(t)>pi)
                roll(t) = roll(t)-2.*pi;
            elseif(roll(t)<-pi)
                roll(t) = roll(t)+2.*pi;
            end
        end
%     end
    x = x(1+dt:1:len-dt);
    y = y(1+dt:1:len-dt);
    z = z(1+dt:1:len-dt);
% end
% 
% roll1 = zeros(1,length(roll));
% pitch1 = zeros(1,length(pitch));
% yaw1 = zeros(1,length(yaw));
% % options = fitoptions('Method', 'SmoothingSpline', 'SmoothingParam', 0.000001);
% % for i = 1:100
% %     f = fit([1:1000]', roll((i-1)*1000+1:i*1000)', 'SmoothingSpline', options);
% %     roll1((i-1)*1000+1:i*1000) = f(1:1000);
% % end
% figure
% plot(roll1(1:1000))
% hold on
% plot(roll(1:1000))
% figure
% plot(pitch(1:1000))
% hold on
% plot(yaw(1:1000))
% roll = roll1;
end