% function GetHeadData()
rng('shuffle');
noisevar = 0.2;
varterm= 0.2;
alpha = 0.3;
dt= 10;
N = 100;
Rmin = pi/3;
inh = 0.05;
extinp = 1;
% rint1 = randi(N-1);
rint1 = 33;
dtinv = 10;
tau = 10;

A = load('animal_movement.mat');
posx = A.posx;
posy = A.posy;

preferencefromsomewhere = (0:N-1)'*2*pi/(N-1) - pi  + noisevar * normrnd(0,pi, N,1);
preferencefromsomewhere1 = [preferencefromsomewhere(rint1+1:end); preferencefromsomewhere(1:rint1)];

W = zeros(N,N);
% W1 = zeros(N,N);
for x = 1:N
    xdiff = abs(preferencefromsomewhere-preferencefromsomewhere(x));
    xdiff = min(xdiff, N-xdiff);
    xdiff1 = abs(preferencefromsomewhere1-preferencefromsomewhere1(x));
    xdiff1 = min(xdiff1, N-xdiff1);
    W(x,logical((xdiff.^2 + xdiff1.^2).^0.5>Rmin)) = -inh;
end

S = zeros(N,1); %Usual HD
for i = 1:floor(N/2)
    S(ceil(rand()*(N))) = rand();
end

numStable = 201;
for t = 1:numStable %% let stable pattern form
    S = S + 1./(dtinv+tau) * (-S + max(0., extinp+W*S));
 end

len = length(posx);
Sout = zeros(N,len);
angs = zeros(len, 1);
for t = dt+1:length(posx)-dt
    ang = atan2((posy(t+dt)-posy(t-dt)),(posx(t+dt)- posx(t-dt)));
    angs(t,:) = ang;
    
    %% inp 0
    dd = ang-preferencefromsomewhere;
    if(sum(dd>pi)>0)
        dd(dd>pi) = dd(dd>pi)-2.*pi;
    end
    if(sum(dd<-pi)>0)
        dd(dd<-pi) = dd(dd<-pi)+2.*pi;
    end
    inp = alpha * exp( - dd.^2 / (2.*varterm) );
    
    %% inp 1
    dd1 = ang-preferencefromsomewhere1;
    if(sum(dd1>pi)>0)
        dd1(dd1>pi) = dd1(dd1>pi)-2.*pi;
    end
    if(sum(dd1<-pi)>0)
        dd1(dd1<-pi) = dd1(dd1<-pi)+2.*pi;
    end
    inp1 = alpha * exp( - dd1.^2 / (2.*varterm) );
    
    
    %% numerically integrate firing rate
    for i = 1:dt
        S = S + 1./(dtinv+tau) * (-S + max(0., extinp + inp + inp1 + W*S));
    end
    Sout(:,t) = S(:);
end

neurons = 1;%:20:100;
timesteps = 1:1:10000;%size(Sout,2);
figure;
polarplot(angs(timesteps),Sout(neurons,timesteps), '*');
