function dists = computeDissimilarity(dataAll, removeNb, dimPCA, neuronpoint,  euclidDist, orderComplex)
%% Reduce Data and Compute distance/dissimilarity within data

%% remove k-nearest neighbour
if (removeNb>0)
    [IDX, D] = knnsearch(dataAll', dataAll','k', removeNb);
%     meanD = mean(D(:,2:end), 2);
%     minD = min(meanD);
%     maxD = max(meanD);
    [~, I] = sort(D(:,end));
%     thresh = maxD-0.9*(maxD-minD);
    stop = floor(size(dataAll,2)*0.9);
%     stop = 100;ce
    dataAll = dataAll(:,I(1:stop));
end

%% All
if (dimPCA >0)
    if(neuronpoint)
        [coeff, score, latent] = pca(dataAll);
    else
        [coeff, score, latent] = pca(dataAll');
    end
    if (dimPCA > size(score,2))
        dimPCA = size(score,2);
    end
    dataPCA = score(:,1:dimPCA)';
else
    if(neuronpoint)
        dataPCA = dataAll';
    else
        dataPCA = dataAll;
    end
end
figure;
% % scatter(dataPCA(1,:), dataPCA(2,:));
scatter3(dataPCA(1,:), dataPCA(2,:), dataPCA(3,:));
% xlabel('x');
% ylabel('y');
% zlabel('z');
xlabel('1st');
ylabel('2nd');
zlabel('3rd');
if (euclidDist)
    dists = dist(dataPCA);
else
%     dists = distmat(dataPCA, 'chebyshev');
%     dists = mandist(dataPCA');
    sz = size(dataPCA,2);
    dists = zeros(sz);
    for i = 1:sz-1
        for j = i+1:sz
%             r = corr(dataPCA(:,i), dataPCA(:,j), 'type','Spearman');
            r = xcorr(dataPCA(:,i), dataPCA(:,j),0, 'coeff');
            dists(i,j) = 1-r;
            dists(j,i) = 1-r;
        end
    end
end

if (orderComplex)
    U = triu(dists);
    U1 = U(logical(U ~= 0));
    d = sort(U1(:));
    prev = [];
    n = size(dists,1);
    for i = 1:n-1
        for j = i+1:n
            if (dists(i,j)~= 0)
            ind = find(d == dists(i,j));
            if (length(ind)>1)
                prev = [prev dists(i,j)];
                dists(i,j) = ind(length(find(prev == dists(i,j))))/(n*(n-1)*0.5);
            else
                dists(i,j) = ind(1)/(n*(n-1)*0.5);
            end
            else
                dists(i,j) = 0;
            end
            dists(j,i) = dists(i,j);
        end
    end
end
        
% dists(dists==0) = 1e-3;
% dists(logical(eye(size(dists)))) = 0;
% dists = reshape(normc(dists(:)), size(dists));
end