function [dims, births, deaths] = load_ripser_diagram(filename)

file = fopen(filename); %if open;
C = textscan(file,'%s','delimiter', '\n');
fclose(file);
%celldisp(C)

num = sscanf(C{1}{1}, '%*s %*s %*s %d %*s');
dim = sscanf(C{1}{3}, '%*s %*s %*s %*s %d');
s = size(C{1});
l = s(1);
births_temp = zeros(1, l);
dims_temp = zeros(1, l);
deaths_temp = zeros(1, l);
i = 4;
dim = 0;
while i <= l
    b = sscanf(C{1}{i}, '%*c %f %*c %f %*c');
    while isempty(b) == false
        s = size(b);
        if s(1) == 1;
            births_temp(1,i-dim) = b(1);
            deaths_temp(1,i-dim) = -1;
            dims_temp(1,i-dim) = -1;
        else
            births_temp(1,i-dim) = b(1);
            deaths_temp(1,i-dim) = b(2);
            dims_temp(1,i-dim) = dim;
        end
        i = i+1;
        if (i>l)
            break;
        end
        b = sscanf(C{1}{i}, '%*c %f %*c %f %*c');    
    
    end
    if (i>l)
        break;
    end
    dim = sscanf(C{1}{i}, '%*s %*s %*s %*s %d');
    i = i+1;
end
numIntervals = l-dim-3;
births = zeros(1, numIntervals);
dims = zeros(1, numIntervals);
deaths = zeros(1, numIntervals);
maxdeath = max(deaths_temp);

for k = 4:numIntervals+3
births(k-3) = births_temp(k);
dims(k-3) = dims_temp(k);
if (deaths_temp(k) == -1)
deaths(k-3) = maxdeath + 0.1*maxdeath;
else
deaths(k-3) = deaths_temp(k);    
end
births = births';
dims = dims';
deaths = deaths';
end